#!/bin/bash
CC=gcc
CFLAGS="-nostdlib -mthumb-interwork -march=armv5t -mtune=arm1136j-s -mfloat-abi=soft -fPIC -ffunction-sections -Wno-psabi -fno-exceptions -fno-unwind-tables -fomit-frame-pointer -fstrict-aliasing -funswitch-loops -I../../library/headers -Isources-jni -I/usr/lib/jvm/default-java/include -Wa,--noexecstack -c"
CP=cp
CPFLAGS=-r
RM=rm
RMFLAGS="-rf"
MKDIR=mkdir
MKDIRFLAGS=
IMPORT_LIBRARIES="-L../../runtime/binaries/arm-linux-softeabi-v5t/ -L../../library/binaries/arm-linux-softeabi-v5t/ -lyeppp -yeprt"

$RM $RMFLAGS "binaries/arm-linux-softeabi-v5t"
$MKDIR $MKDIRFLAGS "binaries/arm-linux-softeabi-v5t/"
$MKDIR $MKDIRFLAGS "binaries/arm-linux-softeabi-v5t/library/"
$MKDIR $MKDIRFLAGS "binaries/arm-linux-softeabi-v5t/core/"
$MKDIR $MKDIRFLAGS "binaries/arm-linux-softeabi-v5t/math/"

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/core/Add.o sources-jni/core/Add.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/core/Subtract.o sources-jni/core/Subtract.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/core/Multiply.o sources-jni/core/Multiply.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/core/MultiplyAdd.o sources-jni/core/MultiplyAdd.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/core/Negate.o sources-jni/core/Negate.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/core/DotProduct.o sources-jni/core/DotProduct.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/core/SumSquares.o sources-jni/core/SumSquares.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/math/Log.o sources-jni/math/Log.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/math/Exp.o sources-jni/math/Exp.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/library/Init.o sources-jni/library/Init.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/library/Timer.o sources-jni/library/Timer.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/library/Cpu.o sources-jni/library/Cpu.c

$CC -Os $CFLAGS -o binaries/arm-linux-softeabi-v5t/library/String.o sources-jni/library/String.c

$CC -nostdlib -Wl,-soname,libyeppp-jni.so -shared -Wl,--gc-sections binaries/arm-linux-softeabi-v5t/core/Add.o binaries/arm-linux-softeabi-v5t/core/Subtract.o binaries/arm-linux-softeabi-v5t/core/Multiply.o binaries/arm-linux-softeabi-v5t/core/MultiplyAdd.o binaries/arm-linux-softeabi-v5t/core/Negate.o binaries/arm-linux-softeabi-v5t/core/DotProduct.o binaries/arm-linux-softeabi-v5t/core/SumSquares.o binaries/arm-linux-softeabi-v5t/math/Log.o binaries/arm-linux-softeabi-v5t/math/Exp.o binaries/arm-linux-softeabi-v5t/library/Init.o binaries/arm-linux-softeabi-v5t/library/Timer.o binaries/arm-linux-softeabi-v5t/library/Cpu.o binaries/arm-linux-softeabi-v5t/library/String.o -Wl,--no-undefined -Wl,-z,noexecstack -o binaries/arm-linux-softeabi-v5t/libyeppp-jni.so $IMPORT_LIBRARIES

strip binaries/arm-linux-softeabi-v5t/libyeppp-jni.so
strip -R .comment -R .note.gnu.build-id binaries/arm-linux-softeabi-v5t/libyeppp-jni.so

$CP $CPFLAGS binaries/arm-linux-softeabi-v5t/libyeppp-jni.so ../../binaries/linux/armel/libyeppp-jni.so
