/*
 *                       Yeppp! library implementation
 *                   This file is auto-generated by Peach-Py,
 *        Portable Efficient Assembly Code-generator in Higher-level Python,
 *                  part of the Yeppp! library infrastructure
 * This file is part of Yeppp! library and licensed under the New BSD license.
 * See library/LICENSE.txt for the full text of the license.
 */

#include <yepPredefines.h>
#include <yepTypes.h>
#include <yepPrivate.hpp>
#include <core/SumSquares.disp.h>

#if defined(YEP_MICROSOFT_COMPILER) || defined(YEP_INTEL_COMPILER_FOR_WINDOWS)
	#pragma section(".rdata$DispatchTable", read)
	#pragma section(".data$FunctionPointer", read, write)
#endif

extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V32f_S32f_Default(const Yep32f* YEP_RESTRICT numberPointer, Yep32f* YEP_RESTRICT sumSquaresPointer, YepSize length);
#if defined(YEP_X86_CPU)
#endif // YEP_X86_CPU
#if defined(YEP_X64_CPU) && defined(YEP_MICROSOFT_X64_ABI)
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V32f_S32f_Nehalem(const Yep32f* YEP_RESTRICT numberPointer, Yep32f* YEP_RESTRICT sumSquaresPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V32f_S32f_SandyBridge(const Yep32f* YEP_RESTRICT numberPointer, Yep32f* YEP_RESTRICT sumSquaresPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V32f_S32f_Bulldozer(const Yep32f* YEP_RESTRICT numberPointer, Yep32f* YEP_RESTRICT sumSquaresPointer, YepSize length);
#endif // YEP_X64_CPU && YEP_MICROSOFT_X64_ABI
#if defined(YEP_X64_CPU) && defined(YEP_SYSTEMV_X64_ABI)
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V32f_S32f_Nehalem(const Yep32f* YEP_RESTRICT numberPointer, Yep32f* YEP_RESTRICT sumSquaresPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V32f_S32f_SandyBridge(const Yep32f* YEP_RESTRICT numberPointer, Yep32f* YEP_RESTRICT sumSquaresPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V32f_S32f_Bulldozer(const Yep32f* YEP_RESTRICT numberPointer, Yep32f* YEP_RESTRICT sumSquaresPointer, YepSize length);
#endif // YEP_X64_CPU && YEP_SYSTEMV_X64_ABI
YEP_USE_CONST_SECTION(DispatchTable) const FunctionDescriptor<YepStatus (YEPABI*)(const Yep32f* YEP_RESTRICT, Yep32f* YEP_RESTRICT, YepSize)> _dispatchTable_yepCore_SumSquares_V32f_S32f[] = 
{
	#if defined(YEP_X86_CPU)
	#endif // YEP_X86_CPU
	#if defined(YEP_X64_CPU) && defined(YEP_MICROSOFT_X64_ABI)
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V32f_S32f_Nehalem, YepIsaFeaturesDefault, YepX86SimdFeatureSSE | YepX86SimdFeatureSSE3, YepX86SystemFeatureSSE, YepCpuMicroarchitectureNehalem, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V32f_S32f_SandyBridge, YepIsaFeaturesDefault, YepX86SimdFeatureAVX, YepX86SystemFeatureAVX, YepCpuMicroarchitectureSandyBridge, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V32f_S32f_Bulldozer, YepIsaFeaturesDefault, YepX86SimdFeatureAVX | YepX86SimdFeatureFMA4, YepX86SystemFeatureAVX, YepCpuMicroarchitectureBulldozer, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	#endif // YEP_X64_CPU && YEP_MICROSOFT_X64_ABI
	#if defined(YEP_X64_CPU) && defined(YEP_SYSTEMV_X64_ABI)
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V32f_S32f_Nehalem, YepIsaFeaturesDefault, YepX86SimdFeatureSSE | YepX86SimdFeatureSSE3, YepX86SystemFeatureSSE, YepCpuMicroarchitectureNehalem, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V32f_S32f_SandyBridge, YepIsaFeaturesDefault, YepX86SimdFeatureAVX, YepX86SystemFeatureAVX, YepCpuMicroarchitectureSandyBridge, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V32f_S32f_Bulldozer, YepIsaFeaturesDefault, YepX86SimdFeatureAVX | YepX86SimdFeatureFMA4, YepX86SystemFeatureAVX, YepCpuMicroarchitectureBulldozer, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	#endif // YEP_X64_CPU && YEP_SYSTEMV_X64_ABI
	#if defined(YEP_IA64_CPU)
	#endif // YEP_IA64_CPU
	#if defined(YEP_ARM_CPU)
	#endif // YEP_ARM_CPU
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V32f_S32f_Default, YepIsaFeaturesDefault, YepSimdFeaturesDefault, YepSystemFeaturesDefault, YepCpuMicroarchitectureUnknown, "c++", "Naive", "None")
};

extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V64f_S64f_Default(const Yep64f* YEP_RESTRICT numberPointer, Yep64f* YEP_RESTRICT sumSquaresPointer, YepSize length);
#if defined(YEP_X86_CPU)
#endif // YEP_X86_CPU
#if defined(YEP_X64_CPU) && defined(YEP_MICROSOFT_X64_ABI)
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V64f_S64f_Nehalem(const Yep64f* YEP_RESTRICT numberPointer, Yep64f* YEP_RESTRICT sumSquaresPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V64f_S64f_SandyBridge(const Yep64f* YEP_RESTRICT numberPointer, Yep64f* YEP_RESTRICT sumSquaresPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V64f_S64f_Bulldozer(const Yep64f* YEP_RESTRICT numberPointer, Yep64f* YEP_RESTRICT sumSquaresPointer, YepSize length);
#endif // YEP_X64_CPU && YEP_MICROSOFT_X64_ABI
#if defined(YEP_X64_CPU) && defined(YEP_SYSTEMV_X64_ABI)
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V64f_S64f_Nehalem(const Yep64f* YEP_RESTRICT numberPointer, Yep64f* YEP_RESTRICT sumSquaresPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V64f_S64f_SandyBridge(const Yep64f* YEP_RESTRICT numberPointer, Yep64f* YEP_RESTRICT sumSquaresPointer, YepSize length);
extern "C" YEP_LOCAL_SYMBOL YepStatus YEPABI _yepCore_SumSquares_V64f_S64f_Bulldozer(const Yep64f* YEP_RESTRICT numberPointer, Yep64f* YEP_RESTRICT sumSquaresPointer, YepSize length);
#endif // YEP_X64_CPU && YEP_SYSTEMV_X64_ABI
YEP_USE_CONST_SECTION(DispatchTable) const FunctionDescriptor<YepStatus (YEPABI*)(const Yep64f* YEP_RESTRICT, Yep64f* YEP_RESTRICT, YepSize)> _dispatchTable_yepCore_SumSquares_V64f_S64f[] = 
{
	#if defined(YEP_X86_CPU)
	#endif // YEP_X86_CPU
	#if defined(YEP_X64_CPU) && defined(YEP_MICROSOFT_X64_ABI)
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V64f_S64f_Nehalem, YepIsaFeaturesDefault, YepX86SimdFeatureSSE | YepX86SimdFeatureSSE3 | YepX86SimdFeatureSSE2, YepX86SystemFeatureSSE, YepCpuMicroarchitectureNehalem, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V64f_S64f_SandyBridge, YepIsaFeaturesDefault, YepX86SimdFeatureAVX, YepX86SystemFeatureAVX, YepCpuMicroarchitectureSandyBridge, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V64f_S64f_Bulldozer, YepIsaFeaturesDefault, YepX86SimdFeatureAVX | YepX86SimdFeatureFMA4, YepX86SystemFeatureAVX, YepCpuMicroarchitectureBulldozer, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	#endif // YEP_X64_CPU && YEP_MICROSOFT_X64_ABI
	#if defined(YEP_X64_CPU) && defined(YEP_SYSTEMV_X64_ABI)
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V64f_S64f_Nehalem, YepIsaFeaturesDefault, YepX86SimdFeatureSSE | YepX86SimdFeatureSSE3 | YepX86SimdFeatureSSE2, YepX86SystemFeatureSSE, YepCpuMicroarchitectureNehalem, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V64f_S64f_SandyBridge, YepIsaFeaturesDefault, YepX86SimdFeatureAVX, YepX86SystemFeatureAVX, YepCpuMicroarchitectureSandyBridge, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V64f_S64f_Bulldozer, YepIsaFeaturesDefault, YepX86SimdFeatureAVX | YepX86SimdFeatureFMA4, YepX86SystemFeatureAVX, YepCpuMicroarchitectureBulldozer, "asm", YEP_NULL_POINTER, YEP_NULL_POINTER),
	#endif // YEP_X64_CPU && YEP_SYSTEMV_X64_ABI
	#if defined(YEP_IA64_CPU)
	#endif // YEP_IA64_CPU
	#if defined(YEP_ARM_CPU)
	#endif // YEP_ARM_CPU
	YEP_DESCRIBE_FUNCTION_IMPLEMENTATION(_yepCore_SumSquares_V64f_S64f_Default, YepIsaFeaturesDefault, YepSimdFeaturesDefault, YepSystemFeaturesDefault, YepCpuMicroarchitectureUnknown, "c++", "Naive", "None")
};


YEP_USE_DATA_SECTION(FunctionPointer) YepStatus (YEPABI*_yepCore_SumSquares_V32f_S32f)(const Yep32f* YEP_RESTRICT, Yep32f* YEP_RESTRICT, YepSize) = YEP_NULL_POINTER;
YEP_USE_DATA_SECTION(FunctionPointer) YepStatus (YEPABI*_yepCore_SumSquares_V64f_S64f)(const Yep64f* YEP_RESTRICT, Yep64f* YEP_RESTRICT, YepSize) = YEP_NULL_POINTER;

#if defined(YEP_MICROSOFT_COMPILER) || defined(YEP_INTEL_COMPILER_FOR_WINDOWS)
	#pragma code_seg( push, ".text$DispatchFunction" )
#endif

YEP_USE_CODE_SECTION(DispatchFunction) YepStatus YEPABI yepCore_SumSquares_V32f_S32f(const Yep32f* YEP_RESTRICT numberPointer, Yep32f* YEP_RESTRICT sumSquaresPointer, YepSize length) {
	return _yepCore_SumSquares_V32f_S32f(numberPointer, sumSquaresPointer, length);
}

YEP_USE_CODE_SECTION(DispatchFunction) YepStatus YEPABI yepCore_SumSquares_V64f_S64f(const Yep64f* YEP_RESTRICT numberPointer, Yep64f* YEP_RESTRICT sumSquaresPointer, YepSize length) {
	return _yepCore_SumSquares_V64f_S64f(numberPointer, sumSquaresPointer, length);
}

#if defined(YEP_MICROSOFT_COMPILER) || defined(YEP_INTEL_COMPILER_FOR_WINDOWS)
	#pragma code_seg( pop )
#endif
